# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'ChallengeDynamicRequirements',
    'ChallengeStandardRequirements',
    'GetChallengesDynamicChallengeResult',
    'GetChallengesDynamicChallengeRequirementsResult',
    'GetChallengesStandardChallengeResult',
    'GetChallengesStandardChallengeRequirementsResult',
]

@pulumi.output_type
class ChallengeDynamicRequirements(dict):
    def __init__(__self__, *,
                 behavior: Optional[builtins.str] = None,
                 prerequisites: Optional[Sequence[builtins.str]] = None):
        """
        :param builtins.str behavior: Behavior if not unlocked, either hidden or anonymized.
        :param Sequence[builtins.str] prerequisites: List of the challenges ID.
        """
        if behavior is not None:
            pulumi.set(__self__, "behavior", behavior)
        if prerequisites is not None:
            pulumi.set(__self__, "prerequisites", prerequisites)

    @property
    @pulumi.getter
    def behavior(self) -> Optional[builtins.str]:
        """
        Behavior if not unlocked, either hidden or anonymized.
        """
        return pulumi.get(self, "behavior")

    @property
    @pulumi.getter
    def prerequisites(self) -> Optional[Sequence[builtins.str]]:
        """
        List of the challenges ID.
        """
        return pulumi.get(self, "prerequisites")


@pulumi.output_type
class ChallengeStandardRequirements(dict):
    def __init__(__self__, *,
                 behavior: Optional[builtins.str] = None,
                 prerequisites: Optional[Sequence[builtins.str]] = None):
        """
        :param builtins.str behavior: Behavior if not unlocked, either hidden or anonymized.
        :param Sequence[builtins.str] prerequisites: List of the challenges ID.
        """
        if behavior is not None:
            pulumi.set(__self__, "behavior", behavior)
        if prerequisites is not None:
            pulumi.set(__self__, "prerequisites", prerequisites)

    @property
    @pulumi.getter
    def behavior(self) -> Optional[builtins.str]:
        """
        Behavior if not unlocked, either hidden or anonymized.
        """
        return pulumi.get(self, "behavior")

    @property
    @pulumi.getter
    def prerequisites(self) -> Optional[Sequence[builtins.str]]:
        """
        List of the challenges ID.
        """
        return pulumi.get(self, "prerequisites")


@pulumi.output_type
class GetChallengesDynamicChallengeResult(dict):
    def __init__(__self__, *,
                 attribution: builtins.str,
                 category: builtins.str,
                 connection_info: builtins.str,
                 decay: builtins.int,
                 description: builtins.str,
                 function: builtins.str,
                 id: builtins.str,
                 max_attempts: builtins.int,
                 minimum: builtins.int,
                 name: builtins.str,
                 next: builtins.int,
                 requirements: 'outputs.GetChallengesDynamicChallengeRequirementsResult',
                 state: builtins.str,
                 tags: Sequence[builtins.str],
                 topics: Sequence[builtins.str],
                 value: builtins.int):
        """
        :param builtins.str attribution: Attribution to the creator(s) of the challenge.
        :param builtins.str category: Category of the challenge that CTFd groups by on the web UI.
        :param builtins.str connection_info: Connection Information to connect to the challenge instance, useful for pwn or web pentest.
        :param builtins.int decay: The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        :param builtins.str description: Description of the challenge, consider using multiline descriptions for better style.
        :param builtins.str function: Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        :param builtins.str id: Identifier of the challenge.
        :param builtins.int max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param builtins.int minimum: The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        :param builtins.str name: Name of the challenge, displayed as it.
        :param builtins.int next: Suggestion for the end-user as next challenge to work on.
        :param 'GetChallengesDynamicChallengeRequirementsArgs' requirements: List of required challenges that needs to get flagged before this one being accessible. Useful for skill-trees-like strategy CTF.
        :param builtins.str state: State of the challenge, either hidden or visible.
        :param Sequence[builtins.str] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param Sequence[builtins.str] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        :param builtins.int value: The value (points) of the challenge once solved. It is mapped to `initial` under the hood, but displayed as `value` for consistency with the standard challenge.
        """
        pulumi.set(__self__, "attribution", attribution)
        pulumi.set(__self__, "category", category)
        pulumi.set(__self__, "connection_info", connection_info)
        pulumi.set(__self__, "decay", decay)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "function", function)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "max_attempts", max_attempts)
        pulumi.set(__self__, "minimum", minimum)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "next", next)
        pulumi.set(__self__, "requirements", requirements)
        pulumi.set(__self__, "state", state)
        pulumi.set(__self__, "tags", tags)
        pulumi.set(__self__, "topics", topics)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def attribution(self) -> builtins.str:
        """
        Attribution to the creator(s) of the challenge.
        """
        return pulumi.get(self, "attribution")

    @property
    @pulumi.getter
    def category(self) -> builtins.str:
        """
        Category of the challenge that CTFd groups by on the web UI.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter(name="connectionInfo")
    def connection_info(self) -> builtins.str:
        """
        Connection Information to connect to the challenge instance, useful for pwn or web pentest.
        """
        return pulumi.get(self, "connection_info")

    @property
    @pulumi.getter
    def decay(self) -> builtins.int:
        """
        The decay defines from each number of solves does the decay function triggers until reaching minimum. This function is defined by CTFd and could be configured through `.function`.
        """
        return pulumi.get(self, "decay")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        Description of the challenge, consider using multiline descriptions for better style.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def function(self) -> builtins.str:
        """
        Decay function to define how the challenge value evolve through solves, either linear or logarithmic.
        """
        return pulumi.get(self, "function")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Identifier of the challenge.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxAttempts")
    def max_attempts(self) -> builtins.int:
        """
        Maximum amount of attempts before being unable to flag the challenge.
        """
        return pulumi.get(self, "max_attempts")

    @property
    @pulumi.getter
    def minimum(self) -> builtins.int:
        """
        The minimum points for a dynamic-score challenge to reach with the decay function. Once there, no solve could have more value.
        """
        return pulumi.get(self, "minimum")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Name of the challenge, displayed as it.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def next(self) -> builtins.int:
        """
        Suggestion for the end-user as next challenge to work on.
        """
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def requirements(self) -> 'outputs.GetChallengesDynamicChallengeRequirementsResult':
        """
        List of required challenges that needs to get flagged before this one being accessible. Useful for skill-trees-like strategy CTF.
        """
        return pulumi.get(self, "requirements")

    @property
    @pulumi.getter
    def state(self) -> builtins.str:
        """
        State of the challenge, either hidden or visible.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def tags(self) -> Sequence[builtins.str]:
        """
        List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def topics(self) -> Sequence[builtins.str]:
        """
        List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        return pulumi.get(self, "topics")

    @property
    @pulumi.getter
    def value(self) -> builtins.int:
        """
        The value (points) of the challenge once solved. It is mapped to `initial` under the hood, but displayed as `value` for consistency with the standard challenge.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetChallengesDynamicChallengeRequirementsResult(dict):
    def __init__(__self__, *,
                 behavior: builtins.str,
                 prerequisites: Sequence[builtins.str]):
        """
        :param builtins.str behavior: Behavior if not unlocked, either hidden or anonymized.
        :param Sequence[builtins.str] prerequisites: List of the challenges ID.
        """
        pulumi.set(__self__, "behavior", behavior)
        pulumi.set(__self__, "prerequisites", prerequisites)

    @property
    @pulumi.getter
    def behavior(self) -> builtins.str:
        """
        Behavior if not unlocked, either hidden or anonymized.
        """
        return pulumi.get(self, "behavior")

    @property
    @pulumi.getter
    def prerequisites(self) -> Sequence[builtins.str]:
        """
        List of the challenges ID.
        """
        return pulumi.get(self, "prerequisites")


@pulumi.output_type
class GetChallengesStandardChallengeResult(dict):
    def __init__(__self__, *,
                 attribution: builtins.str,
                 category: builtins.str,
                 connection_info: builtins.str,
                 description: builtins.str,
                 id: builtins.str,
                 max_attempts: builtins.int,
                 name: builtins.str,
                 next: builtins.int,
                 requirements: 'outputs.GetChallengesStandardChallengeRequirementsResult',
                 state: builtins.str,
                 tags: Sequence[builtins.str],
                 topics: Sequence[builtins.str],
                 value: builtins.int):
        """
        :param builtins.str attribution: Attribution to the creator(s) of the challenge.
        :param builtins.str category: Category of the challenge that CTFd groups by on the web UI.
        :param builtins.str connection_info: Connection Information to connect to the challenge instance, useful for pwn or web pentest.
        :param builtins.str description: Description of the challenge, consider using multiline descriptions for better style.
        :param builtins.str id: Identifier of the challenge.
        :param builtins.int max_attempts: Maximum amount of attempts before being unable to flag the challenge.
        :param builtins.str name: Name of the challenge, displayed as it.
        :param builtins.int next: Suggestion for the end-user as next challenge to work on.
        :param 'GetChallengesStandardChallengeRequirementsArgs' requirements: List of required challenges that needs to get flagged before this one being accessible. Useful for skill-trees-like strategy CTF.
        :param builtins.str state: State of the challenge, either hidden or visible.
        :param Sequence[builtins.str] tags: List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        :param Sequence[builtins.str] topics: List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        pulumi.set(__self__, "attribution", attribution)
        pulumi.set(__self__, "category", category)
        pulumi.set(__self__, "connection_info", connection_info)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "max_attempts", max_attempts)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "next", next)
        pulumi.set(__self__, "requirements", requirements)
        pulumi.set(__self__, "state", state)
        pulumi.set(__self__, "tags", tags)
        pulumi.set(__self__, "topics", topics)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def attribution(self) -> builtins.str:
        """
        Attribution to the creator(s) of the challenge.
        """
        return pulumi.get(self, "attribution")

    @property
    @pulumi.getter
    def category(self) -> builtins.str:
        """
        Category of the challenge that CTFd groups by on the web UI.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter(name="connectionInfo")
    def connection_info(self) -> builtins.str:
        """
        Connection Information to connect to the challenge instance, useful for pwn or web pentest.
        """
        return pulumi.get(self, "connection_info")

    @property
    @pulumi.getter
    def description(self) -> builtins.str:
        """
        Description of the challenge, consider using multiline descriptions for better style.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Identifier of the challenge.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxAttempts")
    def max_attempts(self) -> builtins.int:
        """
        Maximum amount of attempts before being unable to flag the challenge.
        """
        return pulumi.get(self, "max_attempts")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Name of the challenge, displayed as it.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def next(self) -> builtins.int:
        """
        Suggestion for the end-user as next challenge to work on.
        """
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def requirements(self) -> 'outputs.GetChallengesStandardChallengeRequirementsResult':
        """
        List of required challenges that needs to get flagged before this one being accessible. Useful for skill-trees-like strategy CTF.
        """
        return pulumi.get(self, "requirements")

    @property
    @pulumi.getter
    def state(self) -> builtins.str:
        """
        State of the challenge, either hidden or visible.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def tags(self) -> Sequence[builtins.str]:
        """
        List of challenge tags that will be displayed to the end-user. You could use them to give some quick insights of what a challenge involves.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def topics(self) -> Sequence[builtins.str]:
        """
        List of challenge topics that are displayed to the administrators for maintenance and planification.
        """
        return pulumi.get(self, "topics")

    @property
    @pulumi.getter
    def value(self) -> builtins.int:
        return pulumi.get(self, "value")


@pulumi.output_type
class GetChallengesStandardChallengeRequirementsResult(dict):
    def __init__(__self__, *,
                 behavior: builtins.str,
                 prerequisites: Sequence[builtins.str]):
        """
        :param builtins.str behavior: Behavior if not unlocked, either hidden or anonymized.
        :param Sequence[builtins.str] prerequisites: List of the challenges ID.
        """
        pulumi.set(__self__, "behavior", behavior)
        pulumi.set(__self__, "prerequisites", prerequisites)

    @property
    @pulumi.getter
    def behavior(self) -> builtins.str:
        """
        Behavior if not unlocked, either hidden or anonymized.
        """
        return pulumi.get(self, "behavior")

    @property
    @pulumi.getter
    def prerequisites(self) -> Sequence[builtins.str]:
        """
        List of the challenges ID.
        """
        return pulumi.get(self, "prerequisites")


